!  8-13  NCbNE\[g mċAIďo̎p n
RECURSIVE SUBROUTINE quick_sort( array, n )

  IMPLICIT NONE
  INTEGER, INTENT ( IN ) :: n
  INTEGER, INTENT ( INOUT ) :: array( 1 : n )
  INTEGER ::  pivot, i, j

  IF ( n == 2 ) THEN
    IF ( array( 1 ) > array( 2 ) )  &
                      CALL swap( array( 1 ), array( 2 ) )
    RETURN
  END IF

  pivot = array( 1 + n / 2 ) 
  i = 1
  j = n

  DO                                                 ! dJn

s1: DO                                               ! EփT[`
      IF ( array( i ) >= pivot .OR. i == n ) EXIT s1
      i = i + 1
    END DO s1

s2: DO                                               ! փT[`
      IF ( array( j ) <= pivot .OR. j == 1 ) EXIT s2
      j = j - 1
    END DO s2

    IF ( i > j ) EXIT                                ! dI

    CALL swap( array( i ), array( j ) )                ! ľ
    i = i + 1
    j = j - 1

  END DO
                                                 ! ̃\[g
  IF ( j > 1 ) CALL quick_sort( array( 1 : j ) , j )
  IF ( i < n ) CALL quick_sort( array( i : n ) , n - i + 1 )

CONTAINS

  SUBROUTINE swap( x, y )

    IMPLICIT NONE
    INTEGER, INTENT ( INOUT ) :: x, y
    INTEGER :: temp

    temp = x
    x = y
    y = temp

  END SUBROUTINE swap

END SUBROUTINE quick_sort

PROGRAM ex8_13

  IMPLICIT NONE
  INTEGER, PARAMETER :: n = 25
  INTEGER :: a( 1 : n ), seed, i
  REAL :: uran

  PRINT *, 'Seed?'
  READ *, seed
                                                     ! ̏
  DO i = 1, n
    a( i ) = INT( 100.0E0 * uran( seed ) )
  END DO

  PRINT '( 50I3 )', a

  CALL quick_sort( a , n )             ! zƃTCŸ킽

  PRINT '( 50I3 )', a

END PROGRAM ex8_13

REAL FUNCTION uran( iseed )              ! lԂ֐

  IMPLICIT NONE
  INTEGER, INTENT ( INOUT ) :: iseed
  INTEGER, PARAMETER :: mult = 48828125, mask = 2147483647
  REAL, PARAMETER :: rmax = 2.0E0 ** 31

  iseed = IAND( mult * iseed, mask )
  uran  = REAL( iseed ) / rmax

END FUNCTION uran
