!  8-4  ΍lƏ m֐ɂȂꍇ n
PROGRAM ex8_4

  IMPLICIT NONE
  REAL :: h, phix, err
  REAL, EXTERNAL :: gaussian                       ! O֐錾

  PRINT *, 'Ȃ̕΍ĺH'
  READ *, h

  h = ( h - 50.0E0 ) / 10.0E0              ! W̐KzɊZ
  CALL simpson( gaussian, 0.0E0, h, 16, phix )

  err  = ( 0.5E0 - phix ) * 100.0E0

  PRINT '( 1X, A, F6.2, A )', 'ʂ', err, ' łB'

END PROGRAM ex8_4
! Vv\
SUBROUTINE simpson( func, a, b, kubun, integ )

  IMPLICIT NONE
  INTEGER, INTENT( IN ) :: kubun              ! 敪͂2{
  INTEGER :: i
  REAL, EXTERNAL :: func                            ! INTENT sv
  REAL, INTENT ( IN ) :: a, b
  REAL, INTENT ( OUT ) :: integ
  REAL :: x, dx

  dx = ( b - a ) / ( 2.0E0 * kubun )

  integ = func( a ) + 4.0E0 * func( a + dx ) + func( b )

  DO i = 1, kubun - 1
    x = a + ( 2.0E0 * i ) * dx
    integ = integ + 2.0E0 * func( x ) + 4.0E0 * func( x + dx )
  END DO

  integ = integ * dx / 3.0E0

END SUBROUTINE simpson

REAL FUNCTION gaussian( s )

  IMPLICIT NONE
  REAL, PARAMETER :: rn = 2.506628E0             ! SQRT( 2 * pi )
  REAL, INTENT( IN ) :: s

  gaussian = EXP( - s * s / 2.0E0 ) / rn

END FUNCTION gaussian
